<?php

/**
 * AcidimgCcHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class AcidimgCcHelper
 *
 * https://acidimg.cc/img-59269282df5be.html
 * [post: continue to your image]
 * https://acidimg.cc/upload/big/2017/05/25/59269282df583.jpg
 *
 *
 * looks like the form post needs to include imgContinue: "Continue+to+your+image" as the POST param
 */
class AcidimgCcHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
//        $page = file_get_contents('test/acidimg.cc.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $uri = str_replace('http:', 'https:', $uri);

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=Continue+to+your+image");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * <img class='centred' src='https://acidimg.cc/upload/big/2017/05/25/59269282df583.jpg' alt='031' style='max-width:1000px;'/>
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'https://acidimg.cc/upload/big')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}