<?php

/**
 * ChronosToHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ChronosToHelper
 *
 * http://chronos.to/uhiw6m1lrj4s
 * [post: continue to your image]
 * http://chronos.to/i/030/01872/uhiw6m1lrj4s alt="1_023.jpg"
 *
 * looks like the form post needs to include imgContinue: "Continue+to+image." as the POST param
 */
class ChronosToHelper extends BaseHelper
{
    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
//        $page = file_get_contents('test/detail.chronos.to.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'];
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    /**
     * example HTML from page:
     * <Form method="POST" action=''>
    <input type="hidden" name="op" value="view">
    <input type="hidden" name="id" value="kpsfhjfj45qm">
    <input type="hidden" name="pre" value="1">
    <input type="submit" name="next" value="Continue to image.">
    </Form>
     * @param $uri
     * @return mixed
     */
    public function postForm($uri) {

        $info = parse_url($uri);
        $id = str_replace('/', '', $info['path']);
        $post = array('op'=>'view', 'id'=>$id, 'pre'=>'1', 'next'=>"Continue to image.");
        $post = http_build_query($post, '&');

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="pic"')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }

}