<?php

/**
 * ImaGyHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImaGyHelper
 *
 * https://ima.gy/i/9KjOFw
 * [post: continue to your image]
 * https://ima.gy/upload/big/2017/05/11/59140d97d8e91.jpg
 *
 * looks like the form post needs to include imgContinue: "CONTINUE+TO+IMAGE" as the POST param
 */
class ImaGyHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
//        $page = file_get_contents('test/img.yt.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $uri = str_replace('http:', 'https:', $uri);

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=CONTINUE+TO+IMAGE");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * <img class="centred" src="https://ima.gy/upload/big/2017/05/11/59140d97d8e91.jpg" alt="cover2_642x642" style="max-width:1000px;">
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'https://ima.gy/upload/big')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}