<?php

/**
 * ImagevenueComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImagevenueComHelper
 *
 * http://img269.imagevenue.com/img.php?image=098363967_lij013_123_228lo.jpg
 *  links to
 * http://img269.imagevenue.com/aAfkjfp01fo1i-11618/loc228/098363967_lij013_123_228lo.jpg
 * which contains the image
 * <img id="thepic" onLoad="scaleImg();"   SRC="aAfkjfp01fo1i-11618/loc228/098363967_lij013_123_228lo.jpg" alt="aAfkjfp01fo1i-11618/loc228/098363967_lij013_123_228lo.jpg" >
 * 
 */
class ImagevenueComHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = file_get_contents('test/imagevenue.com.html');
        $info = $this->getImageInfo($page);
        $base = $this->getBaseUri($uri);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($base . $info['link']);
        return $image;
    }

    public function getBaseUri($uri) {
        $parts = parse_url($uri);
        $retval = $parts['scheme'] .'://'. $parts['host'] .'/';
        return $retval;
    }

    /**
     * looking for this img HTML
     * <img id="thepic" onLoad="scaleImg();"   SRC="aAfkjfp01fo1i-11618/loc228/098363967_lij013_123_228lo.jpg" alt="aAfkjfp01fo1i-11618/loc228/098363967_lij013_123_228lo.jpg" >
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, '<img id="thepic"')) {
                $retval['name'] = $this->getImageName($this->getAttribute($image, 'alt'));
                $retval['link'] = $this->getAttribute($image, 'SRC');
            }
        }
        return $retval;
    }
    
    public function getImageName($alt) {
        $parts = explode('/', $alt);
        return array_pop($parts);
    }
}