<?php

/**
 * PicpieOrgHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class PicpieOrgHelper
 *
 */
class PicpieOrgHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $image['name'] = $this->getImageName($uri);
        if (!$image['name']) {
            return false;
        }
        $image['image'] = $this->getPage($this->image_uri);
        return $image;
    }

    /**
     * will receive something like: <img src="http://picpie.org/images/2017/03/21/101407133_x_art_1666_02_lrg.th.jpg" border="0" alt=""/>
     * should return 101407133_x_art_1666_02_lrg.jpg
     */
    public function getImageName($uri) {
        $parts = explode('"',$uri);
        foreach ($parts as $part) {
            if (strstr($part, 'picpie.org/')) {
                $this->image_uri = str_replace('.th.jpg', '.jpg',$part);
                $pieces = explode('/', $this->image_uri);
                $name = array_pop($pieces);
                return $name;
            }
        }
        return false;
    }
    
    /**
     * sendImages
     * This overrides the BaseHelper method
     * with some image hosts, I can determine the URI of the target image by changing the URI to the thumbnail
     * and then request the image directly, bypassing the image host's form post
    */
    public function sendImages() {
        return true;
    }
}