<?php
/**
 * RipperSQLiteDb.php
 *
 * @version $Id: $
 * @package ripper
 * @copyright 2019
 */

class RipperSQLiteDb
{
    private $database = 'laxaeripper.sqlite';

    /**
     * PDO instance
     * @var type
     */
    private $pdo;

    public function __construct() {
        $this->connect();
    }
    /**
     * return in instance of the PDO object that connects to the SQLite database
     * @return \PDO
     */
    public function connect() {
        if ($this->pdo == null) {
            $this->pdo = new \PDO("sqlite:" . $this->database);
        }
        return $this->pdo;
    }
    
    /**
     * expecting an array of three values, title, uri, image_count
     */
    public function insert($data) {
        $sql = 'INSERT INTO `activity` ("id","title","uri","image_count") VALUES (NULL,?,?,?)';
        $stmt = $this->pdo->prepare($sql, $data);
        $rs = $stmt->execute($data);
        return $rs;
    }

    public function getActivity() {
        $sql = 'SELECT * FROM `activity`';
        $stmt = $this->pdo->prepare($sql);
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        $stmt->execute();
        $rows = $stmt->fetchAll();
        return $rows;
    }

    public function clearActivity() {
        $sql = 'DELETE FROM `activity`';
        $stmt = $this->pdo->prepare($sql);
        $rs = $stmt->execute();
        return $rs;
    }
}