<?php
/**
 * rip_albums_in_file.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

function rip_albums_in_file($args, $rip) {
    verbose('loading file: '. $args['filename'], $args['verbose']);

    /**
     * $sets is the variable name of the list of albums (or sets) in the file the user specified.
     * expecting 'title', 'uri' as required array keys.  'start' is an optional array key
     */
    $sets = [];

    if(!file_exists($args['filename'])) {
        displayError(['the file you specified does not exist']);
    }

    

//    $inspect = inspectFile($sets);
//    if (!$inspect['result']) {
//        displayError([$inspect['errors']]);
//    }
    /**
     * Now we can loop through the albums and treat them as a regular album using rip_album() to process
     */
    require_once 'app/rip_thread.php';

    $sets = getSets($args['filename']);

    if (count($sets) === 0) {
        displayError(array('there are no threads or posts in the file to process'));
    }
    
    foreach ($sets as $set) {
        $args['title'] = $set['title'];
        $args['uri'] = $set['uri'];
        if (array_key_exists('start', $set)) {
            $args['start'] = $set['start'];
        }
        $rs[] = rip_thread($args, $rip);
    }
    return $rs;
}

/**
 * expecting a primary key of '$sets' which is an array containing the keys 'title', 'uri' and optionally 'start'
 * @param $file
 * @return bool
 */
function inspectFile($sets) {
    return true;
}

function getSets($filename) {
    $info = pathinfo($filename);

    switch ($info['extension']) {
        case 'php':
            $sets = loadSetsFromPhp($filename);
            break;
        case 'csv':
        case 'txt':
            $sets = loadSetsFromCsv($filename);
            break;
        default:
        displayError(array('Unsupported file format.  Currently can only process .php, .csv or .txt files'));
    }
    return $sets;
}

/**
 * in this case the php file contains a variable $sets which is an array of links of albums to process
 */
function loadSetsFromPhp($filename) {
    require_once($filename);
    return $sets;
}

function loadSetsFromCsv($filename) {
    $sets = array();
    if (($handle = fopen($filename, "r")) !== FALSE) {
        while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
            if (!empty($data[2])) {
                $start = $data[2];
            } else {
                $start = 0;
            }
            $sets[] = array('title'=>$data[0],'uri'=>$data[1], 'start'=>$start);
        }
        fclose($handle);
    }
    return $sets;
}