<?php

require_once 'app/RipperUpdater.php';
require_once 'app/UpdateServer/LocalUpdateServer.php';
require_once 'app/UpdateServer/LaxaeripperUpdateServer.php';

function rip_update($arg, $rip)
{
    verbose(__METHOD__ .' starting ', $rip->getVerbose());
    $up = new RipperUpdater(new LocalUpdateServer());
    //$up = new RipperUpdater(new LaxaeripperUpdateServer());
    $up->setVerbose($rip->getVerbose($rip->setVerbose(true)));

    $current = $up->getCurrentVersion();

    $installed = $rip->getInstalledVersion();
    $compare = version_compare($installed, $current);
    switch ($compare) {
        case '-1':
            echo PHP_EOL;
            echo 'The current version is: ' . $current . PHP_EOL;
            echo 'You are running version: ' . $installed . PHP_EOL;
            echo 'Would you like to update your installation? [y|n]';
            $args['upgrade'] = trim(fgets(STDIN));
            if (strtolower($args['upgrade']) === 'y') {
                $up->setVerbose($rip->getVerbose());
                $retval = $up->upgrade();
                $rs = $up->verify($up->manifest, $retval);
                if ($rs) {
                    echo 'Upgrade successful.'. PHP_EOL;
                }
                return $rs;
            } else {
                echo 'Did not perform upgrade' . PHP_EOL;
                exit;
            }
            break;

        case '0':
            echo 'You are running the current version, congratulations!'. PHP_EOL;
            exit;
            break;

        case '1':
            displayError(['Somehow you are running a more recent version than the current version']);
            break;

        default:
            displayError(['Comparing versions failed']);
            break;
    }
}


